// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:equatable/equatable.dart';
import 'package:wyatt_architecture/wyatt_architecture.dart';

class FormInputMetadata<Extra> extends Equatable
    implements Entity {
  final bool export;
  final String? name;
  final Extra? extra;

  const FormInputMetadata({
    this.export = true,
    this.name,
    this.extra,
  });

  FormInputMetadata<Extra> copyWith({
    bool? export,
    String? name,
    Extra? extra,
  }) =>
      FormInputMetadata<Extra>(
        export: export ?? this.export,
        name: name ?? this.name,
        extra: extra ?? this.extra,
      );

  FormInputMetadata<Extra> clone() => copyWith(
        export: export,
        name: name,
        extra: extra,
      );

  @override
  bool? get stringify => true;

  @override
  List<Object?> get props => [export, name, extra];
}
